#include "Evenement.h"
#include <windows.h>

IEvenement::~IEvenement() throw()
   { }

class EvenementWin32
   : public IEvenement
{
   HANDLE evenement_;
public:
   EvenementWin32(ReinitialisationAutomatique)
      : evenement_(CreateEvent(0, FALSE, FALSE, 0))
   {
   }
   EvenementWin32(ReinitialisationManuelle)
      : evenement_(CreateEvent(0, TRUE, FALSE, 0))
   {
   }
   ~EvenementWin32() throw()
      { CloseHandle(evenement_); }
   bool attendre() const volatile
      { return attendre(INFINITE); }
   bool attendre(const int ms) const volatile
      { return WaitForSingleObject(evenement_, ms) == WAIT_OBJECT_0; }
   void provoquer() const volatile
      { SetEvent(evenement_); }
   void reinitialiser() const volatile
      { ResetEvent(evenement_); }
};

const volatile IEvenement *Evenement::creer(ReinitialisationAutomatique categ)
   { return new EvenementWin32(categ); }
const volatile IEvenement *Evenement::creer(ReinitialisationManuelle categ)
   { return new EvenementWin32(categ); }
void Evenement::liberer(const volatile IEvenement *p) throw()
   { delete p; }
