#include "Mutex.h"
#include "Incopiable.h"
#include <windows.h>

IMutex::~IMutex() throw()
   { }

class MutexWin32
   : Incopiable, public IMutex
{
   HANDLE mutex_;
public:
   MutexWin32()
      : mutex_(CreateMutex(0, FALSE, 0))
   {
   }
   ~MutexWin32() throw()
      { CloseHandle(mutex_); }
   bool obtenir() const volatile
      { return obtenir(INFINITE); }
   bool obtenir(const int ms) const volatile
      { return WaitForSingleObject(mutex_, ms) == WAIT_OBJECT_0; }
   void relacher() const volatile
      { ReleaseMutex(mutex_); }
};

const volatile IMutex *Mutex::creer()
   { return new MutexWin32; }
void Mutex::liberer(const volatile IMutex *p) throw()
   { delete p; }
