#ifndef MUTEX_H
#define MUTEX_H

#include "Incopiable.h"
//
// retoucher l'article sur les mutex portables de h-deb
//
class IMutex
{
public:
   virtual bool obtenir() const volatile throw()= 0;
   virtual bool obtenir(const int ms) const volatile throw()= 0;
   virtual void relacher() const volatile throw()= 0;
protected:
   friend class Mutex;
   virtual ~IMutex() throw() = 0;
};

class Mutex
   : Incopiable
{
   const volatile IMutex *mutex_;
   static const volatile IMutex *creer();
   static void liberer(const volatile IMutex *) throw();
public:
   Mutex()
       : mutex_(creer())
   {
   }
   ~Mutex() throw()
      { liberer(mutex_); }
   bool obtenir() const volatile throw()
      { return mutex_->obtenir(); }
   bool obtenir(const int ms) const volatile throw()
      { return mutex_->obtenir(ms); }
   void relacher() const volatile throw()
      { mutex_->relacher(); }
};

class Autoverrou
{
   const volatile Mutex &mutex_;
public:
   Autoverrou(const volatile Mutex &m) throw()
      : mutex_(m)
   {
      mutex_.obtenir();
   }
   ~Autoverrou() throw()
      { mutex_.relacher(); }
};

#endif
