#define _WIN32_DCOM
#include "../../Commun/Commun/UUID_Fabriques.h" // uuid de fabriques
#include "ChargeurCOM.h"
#include "ConversionChaines.h"
#include "Registry.h"
#include "GestionnaireDeVerrou.h"
#include "FabriqueSomme.h"
#include <windows.h>
#include <string>
#include <iostream>

void LancerContexte();
void ArreterContexte();

int main(int argc, char *argv[])
{
   using std::string;
   using std::cerr;
   using std::cin;
   using std::cout;
   using std::endl;
   if (argc == 2)
   {
      const string
         PREFIXE_WIN = "/", PREFIXE_UNIX = "-",
         PARAM = Majuscules(argv[1]),
         ENREGISTRER = Majuscules ("RegServer"),
         DESENREGISTRER = Majuscules ("UnregServer"),
         LANCEMENTCOM= Majuscules ("Embedding");
      if (PARAM == PREFIXE_WIN  + ENREGISTRER ||
          PARAM == PREFIXE_UNIX + ENREGISTRER)
      {
         // inscription au registre
         HRESULT hr =
            RegisterServer(argv[0],
                           CLSID_FabriqueSommeExterne,
                           "Composant externe dmonstrateur",
                           "Component.Somme.OutOfProc",
                           "Component.Somme.OutOfProc.1",
                           0 );
         if (SUCCEEDED(hr))
            cout << "Inscription russie!" << endl;
         else
            cerr << "chec  l'inscription, code " << hr << endl;
      }
      else if (PARAM == PREFIXE_WIN  + DESENREGISTRER ||
               PARAM == PREFIXE_UNIX + DESENREGISTRER)
      {
         // suppression du registre
         HRESULT hr =
            UnregisterServer(CLSID_FabriqueSommeExterne,
                             "Component.Somme.OutOfProc",
                             "Component.Somme.OutOfProc.1");
         if (SUCCEEDED(hr))
            cout << "Dsinscription russie!" << endl;
         else
            cerr << "chec  la dsinscription, code " << hr << endl;
      }
      else if (PARAM == PREFIXE_WIN  + LANCEMENTCOM ||
               PARAM == PREFIXE_UNIX + LANCEMENTCOM)
      {
         // agir comme un serveur COM
         ChargeurCOM ccom((ChargeurCOM::MultiThreaded()));
         LancerContexte();
         GestionnaireDeVerrou::get().attendre_fin();
         ArreterContexte();
      }
      else
         cerr << "Paramtre non standard: " << argv[1] << endl;
   }
   else
      cerr << "Tentative de lancement de " << argv[0]
           << " en tant que processus autonome: non support" << endl;
}

namespace // localiser les dclarations globales
{
   DWORD Jeton = 0;
   IClassFactory *pFab = 0;
}

void LancerContexte()
{
   ::pFab = new FabriqueSomme;
   CoRegisterClassObject(CLSID_FabriqueSommeExterne,
                         ::pFab,
                         CLSCTX_SERVER,
                         REGCLS_MULTIPLEUSE | REGCLS_SUSPENDED,
                         &::Jeton);
   CoResumeClassObjects();
}

void ArreterContexte()
{
   CoRevokeClassObject(::Jeton);
   ::pFab->Release();
}
